CaptfEncoder
================================
[![GitHub release](https://img.shields.io/github/release/guyoung/CaptfEncoder.svg)](https://github.com/guyoung/CaptfEncoder/releases/latest)

![CaptfEncoder Screenshot](https://github.com/guyoung/CaptfEncoder/raw/master/screenshot/captfencoder-screenshot-1.png)

![CaptfEncoder Extensions Screenshot](https://github.com/guyoung/CaptfEncoder/raw/master/screenshot/captfencoder-screenshot-2.png)


CaptfEncoder是一款可扩展跨平台网络安全工具套件，提供网络安全相关编码转换、古典密码、密码学、非对称加密、特殊编码、杂项等工具，并聚合各类在线工具。

## 使用

### 方法一 直接下载可执行程序

 * 百度网盘 <https://pan.baidu.com/s/1q2N1w44bvYIXLe5gCI5oKA> 密码：k5b9

### 方法二 使用Electron运行

 * git clone https://github.com/guyoung/CaptfEncoder.git
 * cd CaptfEncoder
 * npm install
 * npm start

## 支持操作系统

 * Windows
 * Linux
 * MacOS
 * Other...(Support Node.js)

## 功能介绍

 * 编码转换
   * Ascii Encoding
   * Web Encoding
   * Hex Encoding
   * Unicode Encoding
   * Base64、Base Serial
   * Url Encoding
   * Html Entity Encoding
   * Escape Encoding
   * Quoted-printable（可打印字符引用编码）
   * Morse Code（莫尔斯电码）
   * Tap Code（敲击码）

 * 古典密码
   * Rail-fence（栅栏密码）
   * Atbash（埃特巴什码）
   * Caesar（凯撒密码）
   * ROT13、ROT Serial
   * Simple Substitution（简单替换密码）
   * Hill（希尔密码）
   * Polybius Square （波利比奥斯方阵密码）
   * Playfair（普莱菲尔密码）
   * Vigenère（维吉尼亚密码）
   * Autokey（自动密钥密码）
   * Beaufort（博福特密码）
   * Running Key（滚动密钥密码）
   * Porta（Porta 密码）
   * Affine（仿射密码）
   * Baconian（培根密码）
   * ADFGX（ADFGX 密码）
   * ADFGVX（ADFGVX 密码）
   * Bifid（双密码）
   * Four-Square（四方密码）
   * Straddle Checkerboard （跨棋盘密码）
   * Gronsfeld （格罗斯费尔德密码）
 * 密码学
   * Hash
   * MD5、MD Serial
   * SHA1、SHA Serial
   * HMAC
   * Bcrypt
   * Scrypt
   * AES
   * DES
   * 3DES（TripleDES）
   * RC2
   * RC4
   * Rabbit
   * Blowfish 
   * SM3
   * SM4
   * RIPEMD
 * 非对称加密
   * RSA
 * 其他编码
   * JSFuck
   * Jother
   * Brainfuck
   * Ip Encoding
   * Base64 Image Encoding 
   * QR Code
   * Mime Type
   * CRC
   * Punycode
   * Bubble Babble
   * UUEncode
   * XXEncode
 * 实用工具  
   * 图片Exif
   * Hash类型识别


## 项目网站

 * <https://github.com/guyoung/CaptfEncoder>

## 下载软件

 * 百度网盘 <https://pan.baidu.com/s/1q2N1w44bvYIXLe5gCI5oKA> 密码：k5b9


------------------------------------------------

**关注微信公众号，获取软件最新消息**

![微信公众号](https://mmbiz.qlogo.cn/mmbiz_jpg/5IMiaY073fa7zxH6f5q5EticlwZPsYQtUnpYHspNiczmNyjtCXnR7LAmvpstK4EycfzIQkciboLh1qtWRcCibEPuDhA/0?wx_fmt=jpeg)
